import com.dvelop.d3.server.Document
import com.dvelop.d3.server.core.D3Interface
import com.dvelop.d3.server.exceptions.SQLException
import com.dvelop.d3.server.exceptions.D3Exception
import groovy.transform.Field

D3Interface d3 = getProperty("d3");

def prg			= "migration_akte.groovy";
def version		= "0.1";
def kunde		= "Dr. Kleeberg & Partner GmbH";

/////////////////////////////////////////////////////////////////////////


// debug = 0 => es finden Änderungen am Datenbestand statt
// debug = 1 => es finden keine Änderungen am Datenbestand statt
@Field debug = 0;



// In welcher Tabelle soll nach den zu erstellenden Akten gesucht werden?
@Field zieltabelle = "mig_kreditorenakte_2";


// Konfiguration der Aktenartkürzel
@Field dokuart_sammelakte       = "";
@Field dokuart_hauptakte        = "AKRED";
@Field dokuart_oberregisterakte = "AKROR";
@Field dokuart_registerakte     = "AKRER";



// der hier konfigurierte Wert wird verwendet, wenn kein sonstiger Hauptaktenname gefunden wird.
@Field standard_hauptaktenname  = "Kreditorakte";


// DDF 1 / ADM_Aktentyp aus der Aktenart ADM_Verwaltung Mandantenakte (AVMNT) - mit diesem Schlüssel werden die benötigten (Ober-)Register aus den Stammdaten in der Aktenart AVMNT ermittelt.
@Field aktenschluessel  = "Kreditorenakte";




/////////////////////////////////////////////////////////////////////////

def debugtext;

switch (debug)
{
	case 0:
		debugtext = "ausgeschaltet";
		break;
	default:
		debugtext = "eingeschaltet (keine Aenderungen am Datenbestand)";
		break;
}



xlog( d3, 4, "************************************************" );
xlog( d3, 4, "* Programm         : " + prg );
xlog( d3, 4, "* Version          : " + version );
xlog( d3, 4, "* Kunde            : " + kunde );
xlog( d3, 4, "* geschrieben von  : calb / d.velop AG" );
xlog( d3, 4, "* (c) d.velop AG" );
xlog( d3, 4, "************************************************" );


xlog( d3, 4, "Parameter: " );
xlog( d3, 4, "* DEBUG                     : " + debugtext );
xlog( d3, 4, "* Aktenart Sammelakte       : " + dokuart_sammelakte );
xlog( d3, 4, "* Aktenart Hauptakte        : " + dokuart_hauptakte );
xlog( d3, 4, "* Aktenart Oberregisterakte : " + dokuart_oberregisterakte );
xlog( d3, 4, "* Aktenart Registerakte     : " + dokuart_registerakte );
xlog( d3, 4, "* Zieltabelle               : " + zieltabelle );
xlog( d3, 4, "* Standard-Hauptaktenname   : " + standard_hauptaktenname );
xlog( d3, 4, "* Aktenschluessel           : " + aktenschluessel );




xlog( d3, 4, "************************************************" );




def sqlQuery = "select top (100) id,ddf48,ddf10,ddf20,ddf19,ddf22,ddf62,ddf69 from " + zieltabelle + " where fehler is null and doku_id is null";

treffer = d3.sql.executeAndGet( (String) sqlQuery );

xlog( d3, 4, " Es wurden " + treffer.size() + " Treffer gefunden." );
xlog( d3, 4, "************************************************" );

if ( treffer.size() > 0 )
{
	for ( i = 0; i < treffer.size(); i++ )
	{
		// Prüfung, ob die Mandantnummer in der Aktennummer zu der Mandantnummer aus der Tabelle passt - andernfalls Fehler.
		
		def mandantnr_aus_aktennr = treffer[ i ].ddf10.substring( 0, 5 );
		
		if ( mandantnr_aus_aktennr == treffer[ i ].ddf19 )
		{
			// Es wird eine neue Hauptakte erstellt
			
			def newDocfield_19, newDocfield_10, newDocfield_20, newDocfield_22, newDocfield_48, newDocfield_62 = [ ], newDocfield_69 = [ ];
			
			xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": setze Aktennummer DDF10                   : [" + treffer[ i ].ddf10 + "]" );
			newDocfield_10	= treffer[ i ].ddf10;
			
			xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": setze Kreditornummer DDF19                : [" + treffer[ i ].ddf19 + "]" );
			newDocfield_19	= treffer[ i ].ddf19;
			
			xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": setze Kreditorname DDF20                  : [" + treffer[ i ].ddf20 + "]" );
			newDocfield_20	= treffer[ i ].ddf20;
			
			def dddf22 = "Digital";
			
			if ( ( ! treffer[ i ].ddf22 ) || ( treffer[ i ].ddf22 == 'null' ) )
			{
				xlog( d3, 3, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": physischer Aufbewahrungsort DDF22 wurde nicht angegeben, default: [" + dddf22 + "]" );
			}
			else
			{
				dddf22 = treffer[ i ].ddf22;
			}
			
			xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": setze physischer Aufbewahrungsort DDF22   : [" + dddf22 + "]" );
			newDocfield_22	= dddf22;
			
			xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": setze Unique-ID Migration DDF48           : [" + treffer[ i ].ddf48 + "]" );
			newDocfield_48	= treffer[ i ].ddf48;
			
			// Freigeber
			if ( treffer[ i ].ddf62 )
			{
				def splitted_str_array = treffer[ i ].ddf62.split( ';' );
				for ( int j = 0; j < splitted_str_array.length; j++ )
				{
					def filler = " ";
					if ( j >= 10 )
					{
						filler = "";
					}
					xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Setze Postempfaenger DDF62 / " + filler + j + "           : [" + splitted_str_array[ j ] + "]" );
					newDocfield_62[ j ] = splitted_str_array[ j ];
				}
			}
			
			
			// Berechtigter:
			if ( treffer[ i ].ddf69 )
			{
				def splitted_str_array = treffer[ i ].ddf69.split( ';' );
				for ( int j = 0; j < splitted_str_array.length; j++ )
				{
					def filler = " ";
					if ( j >= 10 )
					{
						filler = "";
					}
					xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Setze Berechtigter DDF69 / " + filler + j + "           : [" + splitted_str_array[ j ] + "]" );
					newDocfield_69[ j ] = splitted_str_array[ j ];
				}
			}
			
			
			// Prüfung, ob zu dieser Hauptakte eine passende Sammelakte existiert
			// Falls ja: Übernahme der Mandantenstammdaten der entsprechenden Akte
			// Falls nein: Fehler in DB eintragen und Abbruch der Verarbeitung dieses Treffers
			
			//sqlQuery = "select doku_id, dok_dat_feld_1, dok_dat_feld_2, dok_dat_feld_13 from firmen_spezifisch where kue_dokuart = '" + dokuart_sammelakte + "' and dok_dat_feld_1 = '" + treffer[ i ].ddf1 + "'";
			
			//ergebnis = d3.sql.executeAndGet( (String) sqlQuery );
			
			if ( true )
			{
				
				// Akte mit Stammdaten und Infos aus der Tabelle "zieltabelle" erstellen
				// Registerstruktur unterhalb ebenfalls erstellen
				
				Document newDoc = d3.archive.newDocument();
				newDoc.type = dokuart_hauptakte;
				
				newDoc.status = Document.DocStatus.DOC_STAT_RELEASE;
				//newDoc.editor = "dvelop";
				
				newDoc.field[ 10 ] = newDocfield_10;
				newDoc.field[ 19 ] = newDocfield_19;
				newDoc.field[ 20 ] = newDocfield_20;
				newDoc.field[ 22 ] = newDocfield_22;
				newDoc.field[ 48 ] = newDocfield_48;
				
				for ( int i = 0; i < newDocfield_62.size(); i++ )
				{
					newDoc.field[ 62 ][ i + 1 ] = newDocfield_62[ i ];
				}
				
				for ( int i = 0; i < newDocfield_69.size(); i++ )
				{
					newDoc.field[ 69 ][ i + 1 ] = newDocfield_69[ i ];
				}
				
				
				xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": =============================" );
				
				//Pruefung ob die anzulegende Akte ggf. schon im System angelegt wurde
				sqlQuery = "select doku_id from firmen_spezifisch where kue_dokuart = '" + dokuart_hauptakte + "' and dok_dat_feld_19 = '" + newDocfield_19 + "' AND dok_dat_feld_10 = '" + newDocfield_10 + "'";
				
				ergebnis = d3.sql.executeAndGet( (String) sqlQuery );
				
				if ( ergebnis.size() > 0 ) {
					//xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Aktenanlage [" + newDoc.field[ 10 ] + "] nicht durchgefuehrt da die Akte bereits existiert, doku_id: [" + ergebnis[ 0 ].doku_id + "]" );
					fehler( d3, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Aktenanlage [" + newDoc.field[ 10 ] + "] nicht durchgefuehrt da die Akte bereits existiert. doku_id: [" + ergebnis[ 0 ].doku_id + "]", (int) treffer[ i ].id );
					xlog( d3, 4, "************************************************" );
					continue;
				}
				
				def aktenanlage_erfolgreich = true;
				
				if ( debug == 0 )
				{
					try
					{
						newDoc = d3.archive.importDocument( newDoc );
					}
					catch ( D3Exception e )
					{
						fehler( d3, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Akte [" + newDoc.field[ 10 ] + "] konnte nicht erzeugt werden: " + e.message, (int) treffer[ i ].id );
						aktenanlage_erfolgreich = false;
					}
					
					if ( aktenanlage_erfolgreich )
					{
						// sichern der erzeugten Doku-ID
						if ( debug == 0 )
						{
							sqlQuery = "update " + zieltabelle + " set doku_id = '" + newDoc.id + "' where id = " + treffer[ i ].id;
							d3.sql.execute( sqlQuery );
							xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Aktenanlage [" + newDoc.field[ 10 ] + "] erfolgreich, doku_id: [" + newDoc.id + "]" );
						}
					}
				}
				else
				{
					xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Keine Aktenanlage fuer [" + newDoc.field[ 10 ] + "] (Debug-Modus eingeschaltet)." );
				}
				
				
				if ( aktenanlage_erfolgreich )
				{
					
					
					xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": =============================" );
					
					//////////////////////////////////////////
					// Ebene unterhalb der Hauptakte anlegen
					// Dokumentart: Hauptakten-Oberregisterakte, darin alle in den Stammdaten angelegten Oberregister
					
					sqlQuery = "select distinct dok_dat_feld_2 from firmen_spezifisch where kue_dokuart = 'AVMNT' and dok_dat_feld_1 = '" + aktenschluessel + "'";
					
					def resultRows = d3.sql.executeAndGet( (String) sqlQuery );
					
					if ( resultRows.size() > 0 )
					{
						resultRows.each
						{
							//xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": erstelle Oberregister-Akte: [" + it.dok_dat_feld_2 + "]" );
							
							Document newDocOReg = d3.archive.newDocument();
							
							newDocOReg.type = dokuart_oberregisterakte;
							
							newDocOReg.status = Document.DocStatus.DOC_STAT_RELEASE;
							//newDocOReg.editor = "dvelop";
							
							newDocOReg.field[ 10 ] = newDocfield_10;
							newDocOReg.field[ 19 ] = newDocfield_19;
							newDocOReg.field[  3 ] = it.dok_dat_feld_2; // Oberregister
							newDocOReg.field[ 20 ] = newDocfield_20;
							newDocOReg.field[ 22 ] = newDocfield_22;
							
							
							for ( int i = 0; i < newDocfield_69.size(); i++ )
							{
								newDocOReg.field[ 69 ][ i + 1 ] = newDocfield_69[ i ];
							}
							
							if ( debug == 0 )
							{
								try
								{
									newDocOReg = d3.archive.importDocument( newDocOReg );
								}
								catch ( D3Exception e )
								{
									xlog( d3, 2, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Akte [" + newDoc.field[ 10 ] + "][" + it.dok_dat_feld_2 + "] konnte nicht erzeugt werden: " + e.message );
									aktenanlage_erfolgreich = false;
								}
							}
							else
							{
								xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Keine Aktenanlage fuer [" + newDoc.field[ 10 ] + "][" + it.dok_dat_feld_2 + "] (Debug-Modus eingeschaltet)." );
							}
							
							if ( ( aktenanlage_erfolgreich ) && ( debug == 0 ) )
							{
								//xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Aktenanlage erfolgreich, doku_id: [" + newDoc.id + "][" + newDocOReg.id + "]" );
								xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Aktenanlage erfolgreich, doku_id: [" + newDoc.id + "][" + newDocOReg.id + "] Register: [" + newDoc.field[ 10 ] + "][" + it.dok_dat_feld_2 + "]" );
							}
						}
					}
				}
				else
				{
					xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Weitere Akten werden wegen Fehler nicht angelegt." );
				}
				
				xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": =============================" );
				
				if ( aktenanlage_erfolgreich )
				{
					//////////////////////////////////////////
					// Ebene unterhalb der Hauptakten-Oberregisterakte anlegen
					// Dokumentart: Hauptakten-Registerakte, darin alle in den Stammdaten angelegten Register
					
					sqlQuery = "select distinct dok_dat_feld_2, dok_dat_feld_3 from firmen_spezifisch where kue_dokuart = 'AVMNT' and dok_dat_feld_1 = '" + aktenschluessel + "' and dok_dat_feld_3 != ''";
					
					def resultRows = d3.sql.executeAndGet( (String) sqlQuery );
					
					if ( resultRows.size() > 0 )
					{
						resultRows.each
						{
							//xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": erstelle Register-Akte: [" + it.dok_dat_feld_2 + "][" + it.dok_dat_feld_3 + "]" );
							
							Document newDocReg = d3.archive.newDocument();
							
							newDocReg.type = dokuart_registerakte;
							
							newDocReg.status = Document.DocStatus.DOC_STAT_RELEASE;
							//newDocReg.editor = "dvelop";
							
							newDocReg.field[ 10 ] = newDocfield_10;
							newDocReg.field[ 19 ] = newDocfield_19;
							newDocReg.field[  3 ] = it.dok_dat_feld_2; // Oberregister
							newDocReg.field[ 20 ] = newDocfield_20;
							newDocReg.field[ 22 ] = newDocfield_22;
							newDocReg.field[  4 ] = it.dok_dat_feld_4; // Register
							
							
							
							
							if ( debug == 0 )
							{
								try
								{
									newDocReg = d3.archive.importDocument( newDocReg );
								}
								catch ( D3Exception e )
								{
									xlog( d3, 2, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Akte [" + newDoc.field[ 10 ] + "][" + it.dok_dat_feld_2 + "][" + it.dok_dat_feld_3 + "] konnte nicht erzeugt werden: " + e.message );
									aktenanlage_erfolgreich = false;
								}
							}
							else
							{
								xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Keine Aktenanlage fuer [" + newDoc.field[ 10 ] + "][" + it.dok_dat_feld_2 + "][" + it.dok_dat_feld_3 + "] (Debug-Modus eingeschaltet)." );
							}
							
							if ( ( aktenanlage_erfolgreich ) && ( debug == 0 ) )
							{
								sqlQuery = "select doku_id from firmen_spezifisch where kue_dokuart = '" + dokuart_oberregisterakte + "' and dok_dat_feld_10 = '" + newDoc.field[ 10 ] + "' and dok_dat_feld_3 = '" + it.dok_dat_feld_2 + "'";
								//xlog( d3, 3, sqlQuery );
								e = d3.sql.executeAndGet( sqlQuery );
								def oregdokuid;
								if ( e.size() > 0 ) 
								{
									oregdokuid = e[0].doku_id;
								}
								xlog( d3, 4, treffer[ i ].ddf10 + " / " + treffer[ i ].id + ": Aktenanlage erfolgreich, doku_id: [" + newDoc.id + "][" + oregdokuid + "][" + newDocReg.id + "] Register: [" + newDoc.field[ 10 ] + "][" + it.dok_dat_feld_2 + "][" + it.dok_dat_feld_3 + "]" );
							}
						}
					}
				}
				
			}
			else
			{
				fehler( d3, "Es wurde keine passende Sammelakte gefunden. [" + treffer[ i ].ddf10 + "]", (int) treffer[ i ].id );
			}
			
			xlog( d3, 4, "************************************************" );
			
			
		}
		else
		{
			// Fehler
			fehler( d3, "Kreditornummer in Tabelle und in Aktennummer unterscheiden sich.", (int) treffer[ i ].id );
		}
		
		
		
	}
	
	
}





















def fehler( D3Interface d3, String meldung, int id )
{
	def meldung_db;
	
	if ( meldung.length() > 250 )
	{
		meldung_db = meldung.substring( 0, 249 );
	}
	else
	{
		meldung_db = meldung;
	}
	
	if ( debug == 0 )
	{
		sql = "update " + zieltabelle + " set fehler = '" + meldung_db + "' where id = " + id;
		d3.sql.execute( sql );
	}
	
	xlog( d3, 2, meldung );
}






def xlog( D3Interface d3, int loglevel, String logtext )
{
	def logdatei		= "d:\\d3\\apps\\" + zieltabelle + ".txt";
	def g_loglevel		= 5;
	def g_logdirect		= "BEIDE";  // BEIDE oder D3LOG oder DATEI
	def date			= new Date();
	def zeitstempel		= date.format( "yyyy.MM.dd HH:mm:ss", TimeZone.getTimeZone('CET') );
	def loglevel_lang	= "[INFO ]";
	
	
	
	
	
	if ( loglevel <= g_loglevel )
	{
		switch ( loglevel )
		{
			case 1:
				loglevel_lang   = "[FATAL]";
				
				if ( ( g_logdirect == "D3LOG" ) || ( g_logdirect == "BEIDE" ) )
				{
					d3.log.critical( logtext );
				}
				break;
			case 2:
				loglevel_lang   = "[ERROR]";
				
				if ( ( g_logdirect == "D3LOG" ) || ( g_logdirect == "BEIDE" ) )
				{
					d3.log.error( logtext );
				}
				break;
			case 3:
				loglevel_lang   = "[WARN ]";
				
				if ( ( g_logdirect == "D3LOG" ) || ( g_logdirect == "BEIDE" ) )
				{
					d3.log.warn( logtext );
				}
				break;
			case 4:
				loglevel_lang   = "[INFO ]";
				
				if ( ( g_logdirect == "D3LOG" ) || ( g_logdirect == "BEIDE" ) )
				{
					d3.log.info( logtext );
				}
				break;
			case 5:
				loglevel_lang   = "[DEBUG]";
				// Da die d.3 Server i.d.R. nicht im Debug-Modus laufen, erscheinen DEBUG-Meldungen nicht im Log.
				if ( ( g_logdirect == "D3LOG" ) || ( g_logdirect == "BEIDE" ) )
				{
					d3.log.debug( logtext );
				}
				break;
		}
		
	}
	
	if ( ( g_logdirect == "DATEI" ) || ( g_logdirect == "BEIDE" ) )
	{
		new File( logdatei ).append( zeitstempel + " " + loglevel_lang + " " + logtext + "\n", "UTF8" );
	}
	
	
	return 0;
}


